﻿using System;
using System.Windows.Forms;

namespace TFSIterationPath
{
    public partial class Form1 : Form
    {
        private Tfs tfs;

        public Form1()
        {
            InitializeComponent();
        }

        private void ButtonConnectClick(object sender, EventArgs e)
        {
            LabelProjects.Visible = false;
            Projects.Visible = false;
            IterationPaths.Visible = false;
            LabelIterationPaths.Visible = false;
            LabelWorkItems.Visible = false;
            WorkItems.Visible = false;

            if (string.IsNullOrEmpty(TfsUrl.Text))
            {
                return;
            }

            try
            {
                tfs = new Tfs(new Uri(TfsUrl.Text));
            }
            catch (Exception)
            {
                MessageBox.Show("Could not connect to:" + TfsUrl.Text);
                return;
            }

            LabelProjects.Visible = true;
            Projects.Visible = true;

            Projects.Items.Clear();
            Projects.Items.Add("-- Select --");
            Projects.SelectedIndex = 0;
            foreach (string project in tfs.Projects)
            {
                Projects.Items.Add(project);
            }
        }

        private void ProjectSelectionChanged(object sender, EventArgs e)
        {
            if (Projects.SelectedIndex == 0)
            {
                return;
            }

            var item = (string) Projects.SelectedItem;

            IterationPaths.Visible = true;
            LabelIterationPaths.Visible = true;

            IterationPaths.Items.Clear();
            IterationPaths.Items.Add("-- Select --");
            IterationPaths.SelectedIndex = 0;
            foreach (string path in tfs.GetIterationPaths(item))
            {
                IterationPaths.Items.Add(path);
            }
        }

        private void IterationPathChanged(object sender, EventArgs e)
        {
            if (IterationPaths.SelectedIndex == 0)
            {
                return;
            }

            var item = (string) IterationPaths.SelectedItem;

            LabelWorkItems.Visible = true;
            WorkItems.Visible = true;
            WorkItems.Text = string.Empty;

            foreach (string workItem in tfs.GetWorkItemsInIterationPath(item))
            {
                WorkItems.AppendText(workItem + '\n');
            }
        }
    }
}